unit Boletas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, Grids, DBGrids, Db, DBTables, ExtCtrls;

type
  TFrmBoletas = class(TForm)
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    BtConsultar: TBitBtn;
    BtSair: TBitBtn;
    QryBoletas: TQuery;
    DBGrid1: TDBGrid;
    DsBoletas: TDataSource;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    QryBoletasValor: TCurrencyField;
    QryBoletasNroTitulo: TIntegerField;
    QryBoletasVencimento: TDateField;
    QryBoletasCliente: TStringField;
    QryBoletasEndereco: TStringField;
    QryBoletasCep: TStringField;
    QryBoletasBairro: TStringField;
    QryBoletasCidade: TStringField;
    TbInst: TTable;
    TbInstLinha1: TStringField;
    TbInstLinha2: TStringField;
    TbInstLinha3: TStringField;
    QryBoletasUF: TStringField;
    procedure BtSairClick(Sender: TObject);
    procedure BtConsultarClick(Sender: TObject);
    procedure Impressao;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmBoletas: TFrmBoletas;

implementation

{$R *.DFM}

procedure TFrmBoletas.Impressao;
Var
  I:Integer;
  Arq:TextFile;
  Cliente,Endereco,Bairro,Cep:String;
  Valor,NroTitulo,UF:String;
  Vencimento:String;
Begin
Cliente:=QryBoletasCliente.Value;
Endereco:=QryBoletasEndereco.Value;
Bairro:=QryBoletasBairro.Value;
Cep:=QryBoletasCep.Value;
Uf:=QryBoletasUf.Value;
NroTitulo:=QryBoletasNroTitulo.AsString;
For I:=Length(NroTitulo) to 10 do
NroTitulo:=' '+NroTitulo;
Vencimento:=QryBoletasVencimento.AsString;
Valor:=FloatToStrF(QryBoletasValor.Value,FFCurrency,10,2);
AssignFile(Arq,'LPT1');
ReWrite(Arq);
WriteLn(Arq,'');
WriteLn(Arq,'PAGAVEL EM QUALQUER BANCO ATE O VENCIMENTO  '+ Vencimento);
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,DateToStr(Date)+NroTitulo+'   '+'DUP'+'   '+'S/N'+' '+DateToStr(date));
WriteLn(Arq,'                                               '+Valor);
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,TbInstLinha1.Value);
WriteLn(Arq,TbInstLinha2.Value);
WriteLn(Arq,TbInstLinha3.Value);
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,Cliente);
WriteLn(Arq,Endereco);
WriteLn(Arq,CEP+' '+UF);
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
WriteLn(Arq,'');
CloseFile(Arq);
End;

procedure TFrmBoletas.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmBoletas.BtConsultarClick(Sender: TObject);
begin
Screen.Cursor:=crHourGlass;
with QryBoletas do
  begin
   Close;
   ParamByName('VarNome').AsString:=Edit1.Text+'%';
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   Prepare;
   Open;
  end;
Screen.Cursor:=crDefault;
end;

procedure TFrmBoletas.SpeedButton1Click(Sender: TObject);
begin
Impressao;
end;

procedure TFrmBoletas.SpeedButton2Click(Sender: TObject);
begin
QryBoletas.First;
While not QryBoletas.eof do
  begin
    Impressao;
    QryBoletas.Next;
  end;
end;

procedure TFrmBoletas.FormShow(Sender: TObject);
begin
TbInst.Open;
Data1.Date:=date-15;
Data2.Date:=Date+15;
end;

procedure TFrmBoletas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbInst.Close;
end;

end.
