unit CadClientes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Cadastro, StdCtrls, Buttons, ExtCtrls, Db, DBTables, Grids, DBGrids,
  Mask, DBCtrls, Menus;

type
  TFrmCadClientes = class(TFrmCadastro)
    TbContatos: TTable;
    TbTipos: TTable;
    TbClientes: TTable;
    TbTiposCodigo: TAutoIncField;
    TbTiposTipo: TStringField;
    TbContatosCodCliente: TIntegerField;
    TbContatosCodTipo: TIntegerField;
    TbContatosContato: TStringField;
    TbClientesNome: TStringField;
    TbClientesEndereco: TStringField;
    TbClientesBairro: TStringField;
    TbClientesCidade: TStringField;
    TbClientesUF: TStringField;
    TbClientesCEP: TStringField;
    TbClientesCGC: TStringField;
    TbClientesCPF: TStringField;
    TbClientesIE: TStringField;
    TbContatosTipo: TStringField;
    DsClientes: TDataSource;
    DsContatos: TDataSource;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    DBGrid1: TDBGrid;
    TbControle: TTable;
    TbControleCliente: TIntegerField;
    TbVendedor: TTable;
    TbClientesCodigo: TAutoIncField;
    TbVendedorCodigo: TAutoIncField;
    TbVendedorVendedor: TStringField;
    TbClientesCodVendedor: TIntegerField;
    TbClientesVendedor: TStringField;
    Label11: TLabel;
    DBLookupComboBox1: TDBLookupComboBox;
    PopupMenu2: TPopupMenu;
    Incluir2: TMenuItem;
    Alterar2: TMenuItem;
    Excluir2: TMenuItem;
    TbPrecos: TTable;
    TbPrecosCodCliente: TIntegerField;
    TbPrecosCodProduto: TIntegerField;
    TbPrecosPreco: TCurrencyField;
    DsPrecos: TDataSource;
    DBGrid2: TDBGrid;
    TbProdutos: TTable;
    TbProdutosCodigo: TAutoIncField;
    TbProdutosDescricao: TStringField;
    TbProdutosPrecoCusto: TCurrencyField;
    TbProdutosPrecoVenda: TCurrencyField;
    TbPrecosPrecoVenda: TCurrencyField;
    TbPrecosProduto: TStringField;
    PopupMenu1: TPopupMenu;
    Incluir1: TMenuItem;
    Alterar1: TMenuItem;
    Excluir1: TMenuItem;
    Label12: TLabel;
    Label13: TLabel;
    TbFormaPag: TTable;
    TbFormaPagCodigo: TAutoIncField;
    TbFormaPagDescricao: TStringField;
    TbFormaPagIntervaloDias: TSmallintField;
    TbFormaPagQtdParcelas: TSmallintField;
    TbFormaPagPrimVenc: TSmallintField;
    TbClientesCodFormaPag: TIntegerField;
    TbClientesPontos: TIntegerField;
    TbClientesFormaPag: TStringField;
    Label14: TLabel;
    DBLookupComboBox2: TDBLookupComboBox;
    DBText1: TDBText;
    Label15: TLabel;
    TbClientesDtNascimento: TStringField;
    DBEdit11: TDBEdit;
    Label16: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtSairClick(Sender: TObject);
    procedure BtIncluirClick(Sender: TObject);
    procedure BtConfirmarClick(Sender: TObject);
    procedure Restaura;
    procedure BtAlterarClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
    procedure BtCancelarClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TbClientesAfterInsert(DataSet: TDataSet);
    procedure Incluir2Click(Sender: TObject);
    procedure Alterar2Click(Sender: TObject);
    procedure Excluir2Click(Sender: TObject);
    procedure Incluir1Click(Sender: TObject);
    procedure Alterar1Click(Sender: TObject);
    procedure Excluir1Click(Sender: TObject);
    procedure DBEdit11Exit(Sender: TObject);
  private
    { Private declarations }
  public
    Escolha:Char;
  end;

var
  FrmCadClientes: TFrmCadClientes;

implementation

uses Principal, ConsClientes, Global;

{$R *.DFM}

procedure tfrmcadclientes.restaura;
begin
  btincluir.enabled:= not btincluir.Enabled;
  btalterar.enabled:= not btalterar.Enabled;
  btexcluir.enabled:= not btexcluir.Enabled;
  btconfirmar.enabled:= not btconfirmar.Enabled;
  btcancelar.Enabled:= not btcancelar.Enabled;
  dscontatos.Enabled:= not dscontatos.Enabled;
  dsclientes.Enabled:= not dsclientes.Enabled;
  DsPrecos.Enabled:=not DsPrecos.Enabled;
end;

procedure TFrmCadClientes.FormShow(Sender: TObject);
begin
  TbClientes.Open;
  TbTipos.Open;
  TbContatos.Open;
  TbVendedor.Open;
  TbPrecos.Open;
  TbProdutos.Open;
end;

procedure TFrmCadClientes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  TbClientes.Close;
  TbTipos.Close;
  TbContatos.Close;
  TbVendedor.Close;
  TbPrecos.Close;
  TbProdutos.Close;
end;

procedure TFrmCadClientes.BtSairClick(Sender: TObject);
begin
Close;

end;

procedure TFrmCadClientes.BtIncluirClick(Sender: TObject);
begin
  Restaura;
  FrmPrincipal.DataBase.StartTransaction;
  Escolha:='I';
  TbClientes.Append;
  DBLookupComboBox1.setfocus;
  TbClientesPontos.Value:=0;
end;

procedure TFrmCadClientes.BtConfirmarClick(Sender: TObject);
begin
  if (Escolha='I') or (Escolha='A') then
    Begin
       TbClientes.Post;
    End
  Else
    Begin
       While not TbContatos.Eof do
         TbContatos.Delete;
       While not TbPrecos.Eof do
         TbPrecos.Delete;  
       TbClientes.Delete;
    end;
FrmPrincipal.Database.Commit;
Restaura;
end;

procedure TFrmCadClientes.BtAlterarClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
  Application.CreateForm(TFrmConsClientes, FrmConsClientes);
  FrmConsClientes.ShowModal;
Finally
  FrmConsClientes.Free;
End;
 if GlbCodigo<>0 then
   Begin
    Restaura;
    Escolha:='A';
    frmprincipal.database.StartTransaction;
    tbclientes.FindKey([GlbCodigo]);
    Tbclientes.edit;    
   end;


end;

procedure TFrmCadClientes.BtExcluirClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
  Application.CreateForm(TFrmConsClientes, FrmConsClientes);
  FrmConsClientes.ShowModal;
Finally
  FrmConsClientes.Free;
End;
 if GlbCodigo<>0 then
   Begin
    Restaura;
    Escolha:='E';
    frmprincipal.database.StartTransaction;
    tbclientes.FindKey([GlbCodigo]);
   end;
end;

procedure TFrmCadClientes.BtCancelarClick(Sender: TObject);
begin
  tbclientes.cancel;
  frmprincipal.Database.Rollback;
  restaura;
end;

procedure TFrmCadClientes.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  inherited;
if btconfirmar.Enabled then
  begin
    canclose:=false;
    ShowMessage('Finalize a Operao Clicando em "Confirmar" ou "Cancelar"!');
  end;
end;

procedure TFrmCadClientes.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    Perform(WM_NEXTDLGCTL,0,0);
end;

procedure TFrmCadClientes.TbClientesAfterInsert(DataSet: TDataSet);
begin
  inherited;
TbControle.Open;
TbClientesCodigo.Value:=TbControleCliente.Value+1;
TbControle.Edit;
TbControleCliente.Value:=TbControleCliente.Value+1;
TbControle.Post;
TbControle.Close;
end;

procedure TFrmCadClientes.Incluir2Click(Sender: TObject);
begin
  inherited;
TbContatos.Append;
end;

procedure TFrmCadClientes.Alterar2Click(Sender: TObject);
begin
  inherited;
TbContatos.Edit;
end;

procedure TFrmCadClientes.Excluir2Click(Sender: TObject);
begin
  inherited;
 if Application.MessageBox('Deseja Realmente Excluir este Contato?','Itens do Pedido',MB_YESNO+MB_ICONQUESTION)=ID_YES then
  TbContatos.Delete;
end;

procedure TFrmCadClientes.Incluir1Click(Sender: TObject);
begin
  inherited;
TbPrecos.Append;
end;

procedure TFrmCadClientes.Alterar1Click(Sender: TObject);
begin
  inherited;
TbPrecos.Edit;
end;

procedure TFrmCadClientes.Excluir1Click(Sender: TObject);
begin
  inherited;
 if Application.MessageBox('Deseja Realmente Excluir o Preo do Produto?','Preo do Produto',MB_YESNO+MB_ICONQUESTION)=ID_YES then
 TbPrecos.Delete;
end;

procedure TFrmCadClientes.DBEdit11Exit(Sender: TObject);
Var
 DD,MM,S:String;
begin
  S:=DbEdit11.Text;
  DD:=S[1]+S[2];
  MM:=S[3]+S[4];
if not((StrToInt(DD)>=1)and (StrToInt(DD)<=31)) Then
  Begin
    ShowMessage('O Dia '+DD+' Informardo No  Vlido! Proceda a Correo.');
    DbEdit11.SetFocus;
  End
Else if not((StrToInt(MM)>=1)and(StrToInt(MM)<=12)) Then
  Begin
    ShowMessage('O Ms '+MM+' Informardo No  Vlido! Proceda a Correo.');
    DbEdit11.SetFocus;
  End;
end;

end.
