unit CadFornecedores;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Cadastro, StdCtrls, Buttons, ExtCtrls, Db, DBTables, Mask, DBCtrls,
  Grids, DBGrids, Menus, ComCtrls;

type
  TFrmCadFornecedores = class(TFrmCadastro)
    TbFornecedores: TTable;
    DsFornecedores: TDataSource;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    TbTipos: TTable;
    TbContatosF: TTable;
    TbContatosFCodTipo: TIntegerField;
    TbContatosFContato: TStringField;
    TbTiposCodigo: TAutoIncField;
    TbTiposTipo: TStringField;
    DBGrid1: TDBGrid;
    DsContatosF: TDataSource;
    TbContatosFTipo: TStringField;
    TbContatosFCodForncedor: TIntegerField;
    TbControle: TTable;
    TbControleFornecedor: TIntegerField;
    TbFornecedoresCodigo: TIntegerField;
    TbFornecedoresFornecedor: TStringField;
    TbFornecedoresDtCadastro: TDateField;
    TbFornecedoresEndereco: TStringField;
    TbFornecedoresBairro: TStringField;
    TbFornecedoresCidade: TStringField;
    TbFornecedoresUF: TStringField;
    TbFornecedoresCEP: TStringField;
    TbFornecedoresCGC: TStringField;
    TbFornecedoresIE: TStringField;
    PopupMenu2: TPopupMenu;
    Incluir2: TMenuItem;
    Alterar2: TMenuItem;
    Excluir2: TMenuItem;
    DataForn: TDateTimePicker;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Restaura;
    procedure BtIncluirClick(Sender: TObject);
    procedure BtAlterarClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
    procedure BtConfirmarClick(Sender: TObject);
    procedure BtCancelarClick(Sender: TObject);
    procedure BtSairClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TbFornecedoresAfterInsert(DataSet: TDataSet);
    procedure Incluir2Click(Sender: TObject);
    procedure Alterar2Click(Sender: TObject);
    procedure Excluir2Click(Sender: TObject);
    procedure DataFornCloseUp(Sender: TObject);
  private
    { Private declarations }
  public
Escolha:Char;
  end;

var
  FrmCadFornecedores: TFrmCadFornecedores;

implementation

uses Principal, ConsFornecedores, Global;

{$R *.DFM}

procedure tfrmcadFornecedores.restaura;
begin
  btincluir.enabled:= not btincluir.Enabled;
  btalterar.enabled:= not btalterar.Enabled;
  btexcluir.enabled:= not btexcluir.Enabled;
  btconfirmar.enabled:= not btconfirmar.Enabled;
  btcancelar.Enabled:= not btcancelar.Enabled;
  dscontatosF.Enabled:= not dscontatosF.Enabled;
  dsFornecedores.Enabled:= not dsFornecedores.Enabled;
  DataForn.Enabled:=not DataForn.Enabled;
end;

procedure TFrmCadFornecedores.FormShow(Sender: TObject);
begin
  inherited;
TbFornecedores.Open;
TbContatosF.Open;
TbTipos.Open;
end;

procedure TFrmCadFornecedores.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  inherited;
TbFornecedores.Close;
TbContatosF.Close;
TbTipos.Close;
end;

procedure TFrmCadFornecedores.BtIncluirClick(Sender: TObject);
begin
  inherited;
Restaura;
Escolha:='I';
FrmPrincipal.Database.StartTransaction;
TbFornecedores.Append;
TbFornecedoresDtCadastro.Value:=Date;
end;

procedure TFrmCadFornecedores.BtAlterarClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
   Application.CreateForm(TFrmConsFornecedores, FrmConsFornecedores);
   FrmConsFornecedores.ShowModal;
Finally
   FrmConsFornecedores.Free;
End;
if GlbCodigo<>0 Then
  Begin
    Restaura;
    Escolha:='A';
    FrmPrincipal.Database.StartTransaction;
    TbFornecedores.FindKey([GlbCodigo]);
    TbFornecedores.Edit;
  End;
end;

procedure TFrmCadFornecedores.BtExcluirClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
   Application.CreateForm(TFrmConsFornecedores, FrmConsFornecedores);
   FrmConsFornecedores.ShowModal;
Finally
   FrmConsFornecedores.Free;
End;
if GlbCodigo<>0 Then
  Begin
    Restaura;
    Escolha:='E';
    FrmPrincipal.Database.StartTransaction;
    TbFornecedores.FindKey([GlbCodigo]);
  End;
end;

procedure TFrmCadFornecedores.BtConfirmarClick(Sender: TObject);
begin
if (Escolha='I')or (Escolha='A') Then
Begin
   TbFornecedores.Post;
End
Else
 Begin
    While not TbContatosF.Eof do
     TbContatosF.Delete;
   TbFornecedores.Delete;
 End;
Restaura;
FrmPrincipal.DataBase.Commit;
end;

procedure TFrmCadFornecedores.BtCancelarClick(Sender: TObject);
begin
  inherited;
TbFornecedores.Cancel;
FrmPrincipal.Database.RollBack;
  Restaura;
end;

procedure TFrmCadFornecedores.BtSairClick(Sender: TObject);
begin
  inherited;
Close;
end;

procedure TFrmCadFornecedores.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  inherited;
if btconfirmar.Enabled then
  begin
    canclose:=false;
    ShowMessage('Finalize a Operao Clicando em "Confirmar" ou "Cancelar"!');
  end;
end;

procedure TFrmCadFornecedores.FormKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if key=#13 then
    Perform(WM_NEXTDLGCTL,0,0);
end;

procedure TFrmCadFornecedores.TbFornecedoresAfterInsert(DataSet: TDataSet);
begin
  inherited;
TbControle.Open;
TbFornecedoresCodigo.Value:=TbControleFornecedor.Value;
TbControle.Edit;
TbControleFornecedor.Value:=TbControleFornecedor.Value+1;
TbControle.Post;
TbControle.Close;


end;

procedure TFrmCadFornecedores.Incluir2Click(Sender: TObject);
begin
  inherited;
TbContatosF.Append;
end;

procedure TFrmCadFornecedores.Alterar2Click(Sender: TObject);
begin
  inherited;
TbContatosF.Edit;
end;

procedure TFrmCadFornecedores.Excluir2Click(Sender: TObject);
begin
  inherited;
 if Application.MessageBox('Deseja Realmente Excluir este Contato?','Itens do Pedido',MB_YESNO+MB_ICONQUESTION)=ID_YES then
  TbContatosF.Delete;
end;

procedure TFrmCadFornecedores.DataFornCloseUp(Sender: TObject);
begin
  inherited;
TbFornecedoresDtCadastro.Value:=DataForn.Date;
end;

end.
