unit CadProdutos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, Db, DBTables, StdCtrls, Buttons;

type
  TFrmCadProdutos = class(TForm)
    TbProdutos: TTable;
    DsProdutos: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    BtExcluir: TBitBtn;
    BtSair: TBitBtn;
    TbProdutosCodigo: TAutoIncField;
    TbProdutosDescricao: TStringField;
    TbProdutosModelo: TStringField;
    TbProdutosSaldo: TIntegerField;
    TbProdutosPrecoCusto: TCurrencyField;
    TbProdutosPrecoVenda: TCurrencyField;
    TbProdutosPonto: TIntegerField;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtSairClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmCadProdutos: TFrmCadProdutos;

implementation

{$R *.DFM}

procedure TFrmCadProdutos.FormShow(Sender: TObject);
begin
TbProdutos.Open;
TbProdutos.Refresh;
end;

procedure TFrmCadProdutos.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
TbProdutos.Close;
end;

procedure TFrmCadProdutos.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmCadProdutos.BtExcluirClick(Sender: TObject);
begin
if Application.MessageBox('Deseja Realmente Excluir esse Produto?','Produtos',MB_YESNO+MB_ICONQUESTION)=ID_YES then
TbProdutos.Delete;
end;

procedure TFrmCadProdutos.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
if Key=#13 then
  Begin
    If DbGrid1.SelectedIndex<>4 Then
      Begin
       DbGrid1.SelectedIndex:=DbGrid1.SelectedIndex+1;
      end
    Else
      Begin
        if (DbGrid1.SelectedIndex=4)and(TbProdutos.Eof) then
          Begin
            TbProdutos.Append;
            DbGrid1.SelectedIndex:=0;
          End
       Else
          Begin
            TbProdutos.Next;
            DbGrid1.SelectedIndex:=0;
          End;
      End;
  End;
end;

end.
