unit CadVendedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Cadastro, StdCtrls, Buttons, ExtCtrls, Db, Mask, DBCtrls, DBTables,
  ComCtrls;

type
  TFrmCadVendedor = class(TFrmCadastro)
    TbVendedor: TTable;
    TbVendedorCodigo: TAutoIncField;
    TbVendedorVendedor: TStringField;
    TbVendedorEndereco: TStringField;
    TbVendedorBairro: TStringField;
    TbVendedorCidade: TStringField;
    TbVendedorUF: TStringField;
    TbVendedorCEP: TStringField;
    TbVendedorTelefone1: TStringField;
    TbVendedorTelefone2: TStringField;
    TbVendedorData: TDateField;
    TbVendedorCPF: TStringField;
    TbVendedorRG: TStringField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DsVendedor: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    Label12: TLabel;
    DBEdit12: TDBEdit;
    DtVendedor: TDateTimePicker;
    TbVendedorComisao: TSmallintField;
    Label9: TLabel;
    DBEdit13: TDBEdit;
    Label13: TLabel;
    procedure Restaura;
    procedure BtSairClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtIncluirClick(Sender: TObject);
    procedure BtConfirmarClick(Sender: TObject);
    procedure BtCancelarClick(Sender: TObject);
    procedure BtSairKeyPress(Sender: TObject; var Key: Char);
    procedure DtVendedorCloseUp(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BtAlterarClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
  private
    { Private declarations }
  public
    Escolha:Char;
  end;

var
  FrmCadVendedor: TFrmCadVendedor;

implementation

uses Global, ConsVendedor;

{$R *.DFM}

procedure TFrmCadVendedor.Restaura;
begin
  btincluir.enabled:= not btincluir.Enabled;
  btalterar.enabled:= not btalterar.Enabled;
  btexcluir.enabled:= not btexcluir.Enabled;
  btconfirmar.enabled:= not btconfirmar.Enabled;
  btcancelar.Enabled:= not btcancelar.Enabled;
  DsVendedor.Enabled:= not DsVendedor.Enabled;
  DtVendedor.Enabled:=not DtVendedor.Enabled;
end;

procedure TFrmCadVendedor.BtSairClick(Sender: TObject);
begin
  inherited;
Close;
end;

procedure TFrmCadVendedor.FormShow(Sender: TObject);
begin
  inherited;
 TbVendedor.Open;
end;

procedure TFrmCadVendedor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  inherited;
 TbVendedor.Close;
end;

procedure TFrmCadVendedor.BtIncluirClick(Sender: TObject);
begin
 TbVendedor.Append;
 Escolha:='I';
 TbVendedorData.Value:=Date;
 Restaura;
 DbEdit2.SetFocus;
end;

procedure TFrmCadVendedor.BtConfirmarClick(Sender: TObject);
begin
  if (Escolha='I') or (Escolha='A') Then
    Begin
     TbVendedor.Post;
    End
  Else
    Begin
     TbVendedor.Delete;
    End;
Restaura;
end;

procedure TFrmCadVendedor.BtCancelarClick(Sender: TObject);
begin
 TbVendedor.Cancel;
 Restaura;
end;

procedure TFrmCadVendedor.BtSairKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  Begin
   Perform(WM_NEXTDLGCTL,0,0);
  End;

end;

procedure TFrmCadVendedor.DtVendedorCloseUp(Sender: TObject);
begin
 TbVendedorData.Value:=DtVendedor.Date;

end;

procedure TFrmCadVendedor.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  Begin
    Perform(WM_NEXTDLGCTL,0,0);
  end;
end;

procedure TFrmCadVendedor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 if btConfirmar.Enabled then
   Begin
    canclose:=false;
    ShowMessage('Finalize a Operao Clicando em "Confirmar" ou "Cancelar"!');
   End;

end;

procedure TFrmCadVendedor.BtAlterarClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
  Application.CreateForm(TFrmConsVendedor, FrmConsVendedor);
  FrmConsVendedor.ShowModal;
Finally
  FrmConsVendedor.Free;
End;
if GlbCodigo<>0 then
 Begin
  Restaura;
  Escolha:='A';
  TbVendedor.FindKey([GlbCodigo]);
  TbVendedor.Edit;
 end
end;

procedure TFrmCadVendedor.BtExcluirClick(Sender: TObject);
begin
GlbCodigo:=0;
Try
  Application.CreateForm(TFrmConsVendedor, FrmConsVendedor);
  FrmConsVendedor.ShowModal;
Finally
  FrmConsVendedor.Free;
End;
if GlbCodigo<>0 then
 Begin
  Restaura;
  Escolha:='E';
  TbVendedor.FindKey([GlbCodigo]);
 end

end;

end.
