unit GrfTotCompraCli;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, TeEngine, Series, ExtCtrls, TeeProcs,
  Chart, DBChart, ComCtrls, StdCtrls, Buttons, QrTee, QuickRpt, Qrctrls;

type
  TFrmGrfTotCompraCli = class(TForm)
    QryGrafico: TQuery;
    DBChart1: TDBChart;
    Series1: TPieSeries;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    BitBtn1: TBitBtn;
    QryGraficoNome: TStringField;
    QryGraficoTotal: TCurrencyField;
    BtSair: TBitBtn;
    Panel2: TPanel;
    QuickRep1: TQuickRep;
    TitleBand1: TQRBand;
    QRChart1: TQRChart;
    QRDBChart1: TQRDBChart;
    Series2: TPieSeries;
    BitBtn2: TBitBtn;
    SummaryBand1: TQRBand;
    QRLabel1: TQRLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Data1CloseUp(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BtSairClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure QRLabel1Print(sender: TObject; var Value: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmGrfTotCompraCli: TFrmGrfTotCompraCli;

implementation

{$R *.DFM}

procedure TFrmGrfTotCompraCli.FormShow(Sender: TObject);
begin
Data1.Date:=Date-30;
Data2.Date:=Date;

end;

procedure TFrmGrfTotCompraCli.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
QryGrafico.Close;
end;

procedure TFrmGrfTotCompraCli.Data1CloseUp(Sender: TObject);
begin
if data1.date>data2.date then
  Begin
    ShowMessage('A Data Inicial no Pode ser menor que a Data Final!');
    data1.date:=data2.date;
  end;
end;

procedure TFrmGrfTotCompraCli.BitBtn1Click(Sender: TObject);
begin
With QryGrafico do
  Begin
   Close;
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   Prepare;
   Open;
  End;
If (QryGrafico.RecordCount=1) and (QryGraficoTotal.Value=0) then
 ShowMessage('No Existe Vendas Neste Perodo Informado!');  
end;

procedure TFrmGrfTotCompraCli.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmGrfTotCompraCli.BitBtn2Click(Sender: TObject);
begin
QuickRep1.Preview;
end;

procedure TFrmGrfTotCompraCli.QRLabel1Print(sender: TObject;
  var Value: String);
begin
Value:='Relatrio de Total de Compras por Cliente entre '+DateToStr(Data1.Date)+' e '+DateToStr(Data2.Date);
end;

end.
