unit MaSenha;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Db, Mask, DBTables, Grids, DBGrids, Buttons, ExtCtrls;

type
  TFrmMaSenha = class(TForm)
    TbSenhas: TTable;
    TbSenhasUsuario: TStringField;
    TbSenhasSenha: TStringField;
    TbSenhasNivel: TSmallintField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DsSenhas: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    DBGrid1: TDBGrid;
    Label3: TLabel;
    BtIncluir: TBitBtn;
    BtExcluir: TBitBtn;
    BtSair: TBitBtn;
    Bevel1: TBevel;
    procedure BtSairClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
    procedure BtAlterarClick(Sender: TObject);
    procedure BtIncluirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBEdit2Exit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBEdit2Enter(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    VarSenha:String;
  end;

var
  FrmMaSenha: TFrmMaSenha;

implementation

uses ConfSenha, Global;

{$R *.DFM}

procedure TFrmMaSenha.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmMaSenha.BtExcluirClick(Sender: TObject);
begin
if Application.MessageBox('Deseja Realmente Excluir o Usurio?','Senhas',MB_YESNO+MB_ICONQUESTION)=ID_YES then
TbSenhas.Delete;
end;

procedure TFrmMaSenha.BtAlterarClick(Sender: TObject);
begin
TbSenhas.Edit;
end;

procedure TFrmMaSenha.BtIncluirClick(Sender: TObject);
begin
TbSenhas.Append;
DbEdit1.SetFocus;
DbCheckBox1.Checked:=False;
end;

procedure TFrmMaSenha.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbSenhas.Edit;
TbSenhas.Post;
TbSenhas.Close;
end;

procedure TFrmMaSenha.DBEdit2Exit(Sender: TObject);
begin
if VarSenha<>TbSenhasSenha.Value then
 begin
   GlbSenha:='5354345647';
   Try
     Application.CreateForm(TFrmConfSenha, FrmConfSenha);
     FrmConfSenha.ShowModal;
   Finally
     FrmConfSenha.Free;
   End;
   if GlbSenha=TbSenhasSenha.Value then
    begin
      TbSenhas.Post;
      ShowMessage('A Alterao da Senha foi Confimada com Sucesso!');
    end
   Else
    Begin
      ShowMessage('A Senha no foi Confirmada com Sucesso, Repita a Operao!');
    end;
end;
end;

procedure TFrmMaSenha.FormShow(Sender: TObject);
begin
TbSenhas.Open;
end;

procedure TFrmMaSenha.DBEdit2Enter(Sender: TObject);
begin
VarSenha:=TbSenhasSenha.Value;
end;

procedure TFrmMaSenha.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    Perform(WM_NEXTDLGCTL,0,0);
end;

end.
