unit Nota;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, StdCtrls, Grids, DBGrids, Db, DBTables, ComCtrls,
  Buttons,Printers;

type
  TFrmNota = class(TForm)
    DsPedidos: TDataSource;
    TbPedidos: TQuery;
    TbClientes: TTable;
    TbClientesCodigo: TAutoIncField;
    TbClientesCodVendedor: TIntegerField;
    TbClientesNome: TStringField;
    TbClientesEndereco: TStringField;
    TbClientesBairro: TStringField;
    TbClientesCidade: TStringField;
    TbClientesUF: TStringField;
    TbClientesCEP: TStringField;
    TbClientesCGC: TStringField;
    TbClientesCPF: TStringField;
    TbClientesIE: TStringField;
    TbVendedor: TTable;
    TbVendedorCodigo: TAutoIncField;
    TbVendedorVendedor: TStringField;
    TbVendedorEndereco: TStringField;
    TbVendedorBairro: TStringField;
    TbVendedorCidade: TStringField;
    TbVendedorUF: TStringField;
    TbVendedorCEP: TStringField;
    TbVendedorTelefone1: TStringField;
    TbVendedorTelefone2: TStringField;
    TbVendedorData: TDateField;
    TbVendedorCPF: TStringField;
    TbVendedorRG: TStringField;
    TbVendedorComisao: TSmallintField;
    TbFormaPag: TTable;
    TbFormaPagCodigo: TAutoIncField;
    TbFormaPagDescricao: TStringField;
    TbFormaPagIntervaloDias: TSmallintField;
    TbFormaPagQtdParcelas: TSmallintField;
    TbFormaPagPrimVenc: TSmallintField;
    TbPedidosNumero: TIntegerField;
    TbPedidosCodCliente: TIntegerField;
    TbPedidosCodVendedor: TIntegerField;
    TbPedidosCodFormaPag: TIntegerField;
    TbPedidosDataPed: TDateField;
    TbPedidosEntregue: TBooleanField;
    TbPedidosCliente: TStringField;
    TbPedidosVendedor: TStringField;
    TbPedidosFormaPag: TStringField;
    TbPedidosCGC: TStringField;
    TbPedidosEndereco: TStringField;
    TbPedidosBairro: TStringField;
    TbPedidosCidade: TStringField;
    TbPedidosEstado: TStringField;
    TbPedidosCEP: TStringField;
    TbPedidosCPF: TStringField;
    TbPedidosIE: TStringField;
    TbPedidosObservacao: TMemoField;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    GroupBox1: TGroupBox;
    Data1: TDateTimePicker;
    Label2: TLabel;
    Data2: TDateTimePicker;
    Label4: TLabel;
    BtConsultar: TBitBtn;
    BtSair: TBitBtn;
    Tbitens: TTable;
    TbitensNroPed: TIntegerField;
    TbitensCodProduto: TIntegerField;
    TbitensQuantidade: TSmallintField;
    TbitensPreco: TCurrencyField;
    TbitensTroca: TSmallintField;
    TbitensAliq_ICMS: TCurrencyField;
    TbitensAliq_IPI: TCurrencyField;
    TbProdutos: TTable;
    TbProdutosCodigo: TAutoIncField;
    TbProdutosDescricao: TStringField;
    TbProdutosModelo: TStringField;
    TbProdutosSaldo: TIntegerField;
    TbProdutosPrecoCusto: TCurrencyField;
    TbProdutosPrecoVenda: TCurrencyField;
    TbitensProduto: TStringField;
    TbitensTotal: TCurrencyField;
    TbPedidosLinhas: TSmallintField;
    procedure BtConsultarClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    Procedure Nota;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TbitensCalcFields(DataSet: TDataSet);
    procedure BtSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmNota: TFrmNota;
  Fontes: TStrings;

implementation

{$R *.DFM}

Procedure TFrmNota.Nota;
Var
  VarTotal:Real;
  I:Integer;
  Codigo,Produto,Qtd,Preco,Total,ICMS,IPI:String;
  Arq:TextFile;
  Numero,Vendedor,Data,FormaPag,
  Cliente,CGC,CPF,IE,
  Endereco,Bairro,Cidade,
  Estado,CEP,Obs:String;
Begin
Obs:=TbPedidosObservacao.Value;
Numero:=IntToStr(TbPedidosNumero.Value);
For I:=Length(Numero) to 25 do
Numero:=Numero+' ';
Data:=DateToStr(TbPedidosDataPed.Value);
For I:=Length(Data) to 25 do
Data:=Data+' ';
FormaPag:=TbPedidosFormaPag.Value;
Cliente:=TbPedidosCliente.Value;
CGC:=TbPedidosCGC.Value;
For I:=Length(CGC) to 25 do
CGC:=CGC+' ';
CPF:=TbPedidosCPF.Value;
IE:=TbPedidosIE.Value;
Bairro:=TbPedidosBairro.Value;
For I:=Length(Bairro) to 25 do
Bairro:=Bairro+' ';
Cidade:=TbPedidosCidade.Value;
Endereco:=TbPedidosEndereco.Value;
Estado:=TbPedidosEstado.Value;
For I:=Length(Estado) to 25 do
Estado:=Estado+' ';
Cep:=TbPedidosCEP.Value;
Vendedor:=TbPedidosVendedor.Value;
AssignFile(Arq,'LPT1');
ReWrite(Arq);
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Pedido                              APL MASTER                                  ');
Writeln(Arq,'                         RUA PRIMEIRO DE MARCO, 120/602                         ');
Writeln(Arq,'                    CENTRO-RIO DE JANEIRO-RJ-CEP: 20010-000                     ');
Writeln(Arq,'              TELEFONES: 253-5293 253-5416 233-5084 FAX: 233-6505               ');
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'');
Writeln(Arq,'');
Writeln(Arq,'');
Writeln(Arq,'Numero:   '+Numero+'Vendedor: '+Vendedor);
Writeln(Arq,'Data:     '+Data+'Forma de Pagamento: '+FormaPag);
Writeln(Arq,'Cliente:  '+Cliente);
Writeln(Arq,'CGC:      '+CGC+'Insc. Estadual: '+IE);
Writeln(Arq,'CPF:      '+CPF);
Writeln(Arq,'Endereco: '+Endereco);
Writeln(Arq,'Bairro:   '+Bairro+'Cidade: '+Cidade);
Writeln(Arq,'Estado:   '+Estado+'CEP: '+CEP);
Writeln(Arq,'');
Writeln(Arq,'');
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Codigo Produto                                  QTD    Preco     Total ICMS  IPI');
Writeln(Arq,'--------------------------------------------------------------------------------');
TbItens.First;
While not TbItens.Eof do
  Begin
    Codigo:=IntToStr(TbItensCodProduto.Value);
    Produto:=TbItensProduto.Value;
    Qtd:=IntToStr(TbItensQuantidade.Value);
    Preco:=FloatToStrF(TbItensPreco.Value,FFNumber,15,2);
    Total:=FloatToStrF(TbITensTotal.Value,FFNumber,15,2);
    ICMS:='0';
    IPI:='0';
    For I:=Length(Codigo) to 6 do
    Codigo:=Codigo+' ';
    For I:=Length(Produto) to 35 do
    Produto:=Produto+' ';
    For I:=Length(Qtd) to 7 do
    Qtd:=' '+Qtd;
    For I:=Length(Preco) to 8 do
    Preco:=' '+Preco;
    For I:=Length(Total) to 9 do
    Total:=' '+Total;
    Writeln(Arq,Codigo+Produto+QTD+Preco+Total+'    0    0');
    TbItens.Next;
  End;
For I:=TbItens.RecordCount to 30 do
begin
Writeln(Arq,'');
end;
Writeln(Arq,'--------------------------------------------------------------------------------');
VarTotal:=0;
TbItens.First;
While not TbItens.Eof do
  Begin
   VarTotal:=VarTotal+TbItensTotal.Value;
   TbItens.Next;
  End;

Writeln(Arq,'Valor ICMS: 0,00  Valor IPI: 0,00           Total do Pedido: '+FloatToStrF(VarTotal,FFNumber,15,2));
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Observacoes:');
Writeln(Arq,Obs);
For I:=TbPedidosLinhas.Value to 6 do
  Begin
    Writeln(Arq,'');
  End;
Writeln(Arq,'--------------------------------------------------------------------------------');
CloseFile(arq);
end;

procedure TFrmNota.BtConsultarClick(Sender: TObject);
begin
Screen.Cursor:=crHourGlass;
  With TbPedidos do
    Begin
      Close;
      ParamByName('VarDataI').AsDate:=Data1.Date;
      ParamByName('VarDataF').AsDate:=Data2.Date;
      Prepare;
      Open;
      if RecordCount=0 then
       ShowMessage('No Foi Encontrado Pedidos com Essas Informaes!');
    End;
Screen.Cursor:=crDefault;
end;

procedure TFrmNota.SpeedButton2Click(Sender: TObject);
Var
  I:Integer;
begin
if DbGrid1.SelectedRows.Count>0 then
 Begin
   for I:=0 to DBGrid1.SelectedRows.Count-1 do
     begin
        DbGrid1.DataSource.DataSet.GotoBookmark(Pointer(DbGrid1.SelectedRows.items[I]));
        if TbPedidos.Locate('Numero',DbGrid1.DataSource.DataSet.Fields[0].AsInteger,[]) then
         Begin
          Nota;
         End;
     end;
  End;
end;

procedure TFrmNota.SpeedButton1Click(Sender: TObject);
begin
TbPedidos.First;
While not TbPedidos.eof do
  Begin
    Nota;
    TbPedidos.Next;
  End;
DbGrid1.SelectedRows.Clear;
end;

procedure TFrmNota.FormShow(Sender: TObject);
begin
TbFormaPag.Open;
TbItens.Open;
TbClientes.Open;
TbVendedor.open;
Data1.Date:=Date-30;
Data2.Date:=Date;
end;

procedure TFrmNota.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbFormaPag.Close;
TbItens.Close;
TbClientes.Close;
TbVendedor.Close;
end;

procedure TFrmNota.TbitensCalcFields(DataSet: TDataSet);
begin
TbItensTotal.value:=TbItensQuantidade.value*TbItensPreco.Value;
end;

procedure TFrmNota.BtSairClick(Sender: TObject);
begin
Close;
end;

end.
