unit Principal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls, DBTables, Db, Grids, DBGrids, StdCtrls, Gauges,
  Qrctrls, QuickRpt;

type
  TFrmPrincipal = class(TForm)
    MainMenu1: TMainMenu;
    Cadastro1: TMenuItem;
    Clientes1: TMenuItem;
    N1: TMenuItem;
    Sair1: TMenuItem;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Database: TDatabase;
    Consulta1: TMenuItem;
    Clientes2: TMenuItem;
    Peidos1: TMenuItem;
    Relatrio1: TMenuItem;
    Utilitrios1: TMenuItem;
    BackUp1: TMenuItem;
    Calculadora1: TMenuItem;
    TiposdeContato1: TMenuItem;
    Vendedores1: TMenuItem;
    ListagemdeClientes1: TMenuItem;
    ListagemdeVendedores1: TMenuItem;
    Grafico1: TMenuItem;
    TotaldeCompras1: TMenuItem;
    TotaldeVendasVendedor1: TMenuItem;
    ProdutosVendidos2: TMenuItem;
    Ajuda1: TMenuItem;
    Sobre1: TMenuItem;
    N3: TMenuItem;
    ReltoriodePedidos1: TMenuItem;
    Vendedor1: TMenuItem;
    N2: TMenuItem;
    Produtos1: TMenuItem;
    FormadePagamento1: TMenuItem;
    Baixas1: TMenuItem;
    BaixasporPedidos1: TMenuItem;
    RelatriodeVendedores1: TMenuItem;
    Fornecedores1: TMenuItem;
    Fornecedores2: TMenuItem;
    Entradas1: TMenuItem;
    Entradas2: TMenuItem;
    Database2: TDatabase;
    Session: TSession;
    Logar1: TMenuItem;
    ListagemdeFornecedores1: TMenuItem;
    ManutenodeSenhas1: TMenuItem;
    Vendas1: TMenuItem;
    SaidasdePedidos1: TMenuItem;
    Pedidos1: TMenuItem;
    N4: TMenuItem;
    NotaFiscal1: TMenuItem;
    Especie1: TMenuItem;
    RelatriodeTrocas1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    ZerarPontos1: TMenuItem;
    TbClientes: TTable;
    TbClientesPontos: TIntegerField;
    Label4: TLabel;
    ListagemdePontos1: TMenuItem;
    Gauge1: TGauge;
    ListagemdeVendedoresporCliente1: TMenuItem;
    Pedidos2: TMenuItem;
    ReltoriodeAniversriantes1: TMenuItem;
    DatadaltimaCompradoCliente1: TMenuItem;
    Manuteno1: TMenuItem;
    InstruesparaBoletas1: TMenuItem;
    procedure Trataerros(Sender: TObject; E: Exception);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BackUp1Click(Sender: TObject);
    procedure Clientes1Click(Sender: TObject);
    procedure TiposdeContato1Click(Sender: TObject);
    procedure Clientes2Click(Sender: TObject);
    procedure Produtos1Click(Sender: TObject);
    procedure Vendedores1Click(Sender: TObject);
    procedure Calculadora1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure Pedidos1Click(Sender: TObject);
    procedure Peidos1Click(Sender: TObject);
    procedure ListagemdeClientes1Click(Sender: TObject);
    procedure TotaldeCompras1Click(Sender: TObject);
    procedure TotaldeVendasVendedor1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
    procedure ProdutosVendidos2Click(Sender: TObject);
    procedure Vendedor1Click(Sender: TObject);
    procedure ListagemdeVendedores1Click(Sender: TObject);
    procedure FormadePagamento1Click(Sender: TObject);
    procedure ReltoriodePedidos1Click(Sender: TObject);
    procedure BaixasporPedidos1Click(Sender: TObject);
    procedure RelatriodeVendedores1Click(Sender: TObject);
    procedure Fornecedores1Click(Sender: TObject);
    procedure Fornecedores2Click(Sender: TObject);
    procedure Entradas1Click(Sender: TObject);
    Procedure Nota;
    procedure Entradas2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Logar1Click(Sender: TObject);
    Procedure Permicao;
    procedure Timer2Timer(Sender: TObject);
    procedure ListagemdeFornecedores1Click(Sender: TObject);
    procedure ManutenodeSenhas1Click(Sender: TObject);
    procedure SaidasdePedidos1Click(Sender: TObject);
    procedure Especie1Click(Sender: TObject);
    procedure NotaFiscal1Click(Sender: TObject);
    procedure RelatriodeTrocas1Click(Sender: TObject);
    procedure ZerarPontos1Click(Sender: TObject);
    procedure ListagemdePontos1Click(Sender: TObject);
    procedure ListagemdeVendedoresporCliente1Click(Sender: TObject);
    procedure Pedidos2Click(Sender: TObject);
    procedure ReltoriodeAniversriantes1Click(Sender: TObject);
    procedure DatadaltimaCompradoCliente1Click(Sender: TObject);
    procedure InstruesparaBoletas1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmPrincipal: TFrmPrincipal;

implementation

uses backup, CadClientes, CadTipos, ConsClientes, CadProdutos, CadVendedor,
  CadPedidos, ConsPedidos, ListClientes, GrfTotCompraCli,
  GrfTotVendaVendedor, Sobre, GrfProdutosVendidos, ConsVendedor,
  ListVendedor, CadFormaPag, RelPrincipal, Baixas, Global, CadFornecedores,
  ConsFornecedores, CadEntradas, ConsEntradas, Senha, ListFornecedor,
  MaSenha, SaidaPedidos, CadEspecie, Boletas, ListPontos, 
  Nota, RelClientesVendedor, RelAniversario, ListCompraCli, Inst, Comissao;

{$R *.DFM}

Procedure TFrmPrincipal.Nota;
Var
  Arq:TextFile;
Begin
AssignFile(Arq,'LPT1');
ReWrite(Arq);
WriteLn(Arq,'');
CloseFile(Arq);
End;

Procedure TFrmPrincipal.Permicao;
Var
  I,J:Integer;
begin
 For I:=0 to MainMenu1.Items.Count-1 do
   begin
      For J:=0 To MainMenu1.Items[I].Count-1 do
        Begin
          if (MainMenu1.Items[I].Items[J].Tag) > (GlbNivel) then
          MainMenu1.Items[I].Items[J].Enabled:=False
          Else
          MainMenu1.Items[I].Items[J].Enabled:=True;
        End;
  end;
end;

procedure TFrmPrincipal.Trataerros(Sender: TObject; E: Exception);
var mensagem: string;
    Pos1, Pos2: integer;
begin
   If Pos(UpperCase('is not a valid date'), UpperCase(E.Message)) <> 0 then
           showmessage('Data invlida, proceda a correo.')
   else
      if Pos(UpperCase('must have a value'), UpperCase(E.Message)) <> 0 then
           begin
              Pos1:=Pos('''', E.Message);
              mensagem:=E.Message;
              Delete(mensagem, Pos1, 1);
              Pos2:=Pos('''', mensagem);
              mensagem:=copy(E.Message, Pos1 + 1, Pos2 - Pos1);
              showmessage(' obrigatrio o preenchimento do campo '+ mensagem + '.');
           end
   else
      If Pos(UpperCase('key violation'), UpperCase(E.Message)) <> 0 then
           showmessage('Houve violao de Chave.  Registro j incluido.')
   else
      If Pos(UpperCase('Input value'), UpperCase(E.Message)) <> 0 then
           showmessage('Campo preenchido com valor no vlido. Proceda a correo.')
   else
      If Pos(UpperCase('is not a valid time'), UpperCase(E.Message)) <> 0 then
           showmessage('Hora invlida, proceda a correo.')
   else
      If Pos(UpperCase('master has detail records'), UpperCase(E.Message)) <> 0 then
          ShowMessage('Proibida a Excluso e Modificao deste Registro, pois ele faz Referncia a Outro(s) Registro(s)!')
   else
      If Pos(UpperCase('field value required'), UpperCase(E.Message)) <> 0 then
        Begin
          Pos1:=Pos(':',E.Message);
          Delete(Mensagem,Pos1,1);
          Mensagem:=copy(E.Message,Pos1+2,30);
          showmessage(' obrigatrio o preenchimento do campo "'+ mensagem + '".');
        End;
      If Pos(UpperCase('RECORD LOCKED BY ANOTHER USER.'), UpperCase(E.Message)) <> 0 then
         ShowMessage('O Registro est sendo Utilizado por Outro Usurio da Rede. Cancele a Operao e Aguarde a Liberao do Mesmo!') 
   else
      showmessage('Ocorreu o seguinte erro: '+UpperCase(E.Message));
end;


procedure TFrmPrincipal.FormCreate(Sender: TObject);
begin
  Application.OnException:=TrataErros;
  Session.AddPassword('123');
end;

procedure TFrmPrincipal.Timer1Timer(Sender: TObject);
begin
StatusBar1.Panels[2].Text:=TimeToStr(Time);
StatusBar1.Panels[3].Text:=DateToStr(Date);
end;

procedure TFrmPrincipal.BackUp1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmBackup, FrmBackup);
  FrmBackUp.ShowModal;
Finally
  FrmBackUp.Free;
End;
end;

procedure TFrmPrincipal.Clientes1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadClientes, FrmCadClientes);
  FrmCadClientes.ShowModal;
Finally
  FrmCadClientes.Free;
End;
end;

procedure TFrmPrincipal.TiposdeContato1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadTipos, FrmCadTipos);
  FrmCadTipos.ShowModal;
Finally
  FrmCadTipos.Free;
End;    
end;

procedure TFrmPrincipal.Clientes2Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmConsClientes, FrmConsClientes);
  FrmConsClientes.ShowModal;
Finally
  FrmConsClientes.Free;
End;      
end;

procedure TFrmPrincipal.Produtos1Click(Sender: TObject);
begin
Try
    Application.CreateForm(TFrmCadProdutos, FrmCadProdutos);
    FrmCadProdutos.ShowModal;
Finally
    FrmCadProdutos.Free;
End;
end;

procedure TFrmPrincipal.Vendedores1Click(Sender: TObject);
begin
Try
 Application.CreateForm(TFrmCadVendedor, FrmCadVendedor);
 FrmCadVendedor.ShowModal;
Finally
 FrmCadVendedor.Free;
End;  
end;

procedure TFrmPrincipal.Calculadora1Click(Sender: TObject);
begin
Try
Winexec('Calc.exe',Sw_Show);
Except
ShowMessage('Verifique se a Calculadora foi Instalada pelo Windows!');
End;
end;

procedure TFrmPrincipal.Sair1Click(Sender: TObject);
begin
Close;
end;

procedure TFrmPrincipal.Pedidos1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadPedidos, FrmCadPedidos);
  FrmCadPedidos.ShowModal;
Finally
  FrmCadPedidos.Free;
End;    
end;

procedure TFrmPrincipal.Peidos1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmConsPedidos, FrmConsPedidos);
  FrmConsPedidos.ShowModal;
Finally
  FrmConsPedidos.Free;
End;    
end;

procedure TFrmPrincipal.ListagemdeClientes1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmListClientes, FrmListClientes);
  With FrmListClientes do
    Begin
      TbTipos.Open;
      TbContatos.Open;
      TbClientes.Open;
      QuickRep1.Preview;
      TbContatos.Close;
      TbTipos.Close;
      TbClientes.Close;
    end;
Finally
  FrmListClientes.Free;
end;
end;

procedure TFrmPrincipal.TotaldeCompras1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmGrfTotCompraCli, FrmGrfTotCompraCli);
  FrmGrfTotCompraCli.ShowModal;
  Finally
  FrmGrfTotCompraCli.Free;
End;
end;

procedure TFrmPrincipal.TotaldeVendasVendedor1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmGrfTotVendaVendedor, FrmGrfTotVendaVendedor);
  FrmGrfTotVendaVendedor.ShowModal;
Finally
  FrmGrfTotVendaVendedor.Free;
End;    
end;

procedure TFrmPrincipal.Sobre1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmSobre, FrmSobre);
  FrmSobre.ShowModal;
Finally
  FrmSobre.Free;
End;
end;

procedure TFrmPrincipal.ProdutosVendidos2Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmGrfProdutosVendidos, FrmGrfProdutosVendidos);
  FrmGrfProdutosVendidos.ShowModal;
Finally
  FrmGrfProdutosVendidos.Free;
End;    
end;

procedure TFrmPrincipal.Vendedor1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmConsVendedor, FrmConsVendedor);
  FrmConsVendedor.ShowModal;
Finally
  FrmConsVendedor.Free;
End;    
end;

procedure TFrmPrincipal.ListagemdeVendedores1Click(Sender: TObject);
begin
Try
 Application.CreateForm(TFrmListVendedor, FrmListVendedor);
 FrmListVendedor.TbVendedor.Open;
 FrmListVendedor.QuickRep1.Preview;
 FrmListVendedor.TbVendedor.Close;
Finally
 FrmListVendedor.Free;
End;  
end;

procedure TFrmPrincipal.FormadePagamento1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadFormaPag, FrmCadFormaPag);
  FrmCadFormaPag.ShowModal;
Finally
  FrmCadFormaPag.Free;
End;    
end;

procedure TFrmPrincipal.ReltoriodePedidos1Click(Sender: TObject);
begin
GlbEscolha:='P';
Try
  Application.CreateForm(TFrmRelPrincipal, FrmRelPrincipal);
  FrmRelPrincipal.ShowModal;
Finally
  FrmRelPrincipal.Free;
End;
end;

procedure TFrmPrincipal.BaixasporPedidos1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmBaixas, FrmBaixas);
  FrmBaixas.ShowModal;
Finally
  FrmBaixas.Free;
End;  
end;

procedure TFrmPrincipal.RelatriodeVendedores1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmComissao, FrmComissao);
  FrmComissao.ShowModal;
Finally
  FrmComissao.Free;
End;
end;

procedure TFrmPrincipal.Fornecedores1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadFornecedores, FrmCadFornecedores);
  FrmCadFornecedores.ShowModal;
Finally
  FrmCadFornecedores.Free;
End;
end;

procedure TFrmPrincipal.Fornecedores2Click(Sender: TObject);
begin
Try
   Application.CreateForm(TFrmConsFornecedores, FrmConsFornecedores);
   FrmConsFornecedores.ShowModal;
Finally
   FrmConsFornecedores.Free;
End;
end;

procedure TFrmPrincipal.Entradas1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadEntradas, FrmCadEntradas);
  FrmCadEntradas.ShowModal;
Finally
  FrmCadEntradas.Free;
End;
end;

procedure TFrmPrincipal.Entradas2Click(Sender: TObject);
begin
Try
   Application.CreateForm(TFrmConsEntradas, FrmConsEntradas);
   FrmConsEntradas.ShowModal;
Finally
   FrmConsEntradas.Free;
End;
end;

procedure TFrmPrincipal.FormShow(Sender: TObject);
begin

StatusBar1.Panels[1].Text:='Nvel - '+IntToStr(GlbNivel);

end;

procedure TFrmPrincipal.Logar1Click(Sender: TObject);
begin
FrmSenha.ShowModal;
StatusBar1.Panels[1].Text:='Nvel - '+IntToStr(GlbNivel);
Permicao;
end;

procedure TFrmPrincipal.Timer2Timer(Sender: TObject);
begin
Logar1Click(sender);
end;

procedure TFrmPrincipal.ListagemdeFornecedores1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmListFornecedor, FrmListFornecedor);
  FrmListFornecedor.TbContatosF.Open;
  FrmListFornecedor.TbFornecedor.Open;
  FrmListFornecedor.TbTipos.Open;
  FrmListFornecedor.QuickRep1.Preview;
  FrmListFornecedor.TbContatosF.Close;
  FrmListFornecedor.TbFornecedor.Close;
  FrmListFornecedor.TbTipos.Close;
Finally
  FrmListFornecedor.Free;
End;  
end;

procedure TFrmPrincipal.ManutenodeSenhas1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmMaSenha, FrmMaSenha);
  FrmMaSenha.ShowModal;
Finally
  FrmMaSenha.Free;
end;  
end;

procedure TFrmPrincipal.SaidasdePedidos1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmSaidaPedidos, FrmSaidaPedidos);
  FrmSaidaPedidos.ShowModal;
Finally
  FrmSaidaPedidos.Free;
End;  
end;

procedure TFrmPrincipal.Especie1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmCadEspecie, FrmCadEspecie);
  FrmCadEspecie.ShowModal;
Finally
  FrmCadEspecie.Free;
End;
end;

procedure TFrmPrincipal.NotaFiscal1Click(Sender: TObject);
begin
Try
 Application.CreateForm(TFrmBoletas, FrmBoletas);
 FrmBoletas.ShowModal;
Finally
 FrmBoletas.Free;
End;  
end;

procedure TFrmPrincipal.RelatriodeTrocas1Click(Sender: TObject);
begin
GlbEscolha:='T';
Try
  Application.CreateForm(TFrmRelPrincipal, FrmRelPrincipal);
  FrmRelPrincipal.ShowModal;
Finally
  FrmRelPrincipal.Free;
End;

end;

procedure TFrmPrincipal.ZerarPontos1Click(Sender: TObject);
begin
if Application.MessageBox('Este processo pode demorar alguns minutos. Deseja Continuar?','Apollo Master',MB_YESNO+MB_ICONQUESTION)=ID_YES then
  Begin
    Label4.Visible:=True;
    Gauge1.Visible:=True;
    TbClientes.Open;
    Gauge1.Progress:=0;
    Gauge1.MaxValue:=TbClientes.RecordCount;
    TbClientes.First;
    While not TbClientes.Eof do
       Begin
         TbClientes.Edit;
         TbClientesPontos.Value:=0;
         TbClientes.Post;
         TbClientes.Next;
         Gauge1.Progress:=Gauge1.Progress+1;
       End;
    TbClientes.Close;
    Gauge1.Visible:=False;
    Label4.Visible:=False;
  End;
ShowMessage('O Processo foi Completado com Sucesso!');
end;

procedure TFrmPrincipal.ListagemdePontos1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmListPontos, FrmListPontos);
  with FrmListPontos do
    Begin
      TbClientes.Open;
      QuickRep1.Preview;
      TbClientes.Close;
    End;
Finally
   FrmListPontos.Free;
End;       
end;

procedure TFrmPrincipal.ListagemdeVendedoresporCliente1Click(
  Sender: TObject);
begin
Try
  Application.CreateForm(TFrmRelClientesVendedor, FrmRelClientesVendedor);
  FrmRelClientesVendedor.TbClientes.Open;
  FrmRelClientesVendedor.TbVendedor.Open;
  FrmRelClientesVendedor.QuickRep1.Preview;
  FrmRelClientesVendedor.TbClientes.Close;
  FrmRelClientesVendedor.TbVendedor.Close;
Finally
  FrmRelClientesVendedor.Free;
End;
end;

procedure TFrmPrincipal.Pedidos2Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmNota, FrmNota);
  FrmNota.ShowModal;
Finally
  FrmNota.Free;
End;    
end;

procedure TFrmPrincipal.ReltoriodeAniversriantes1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmRelAniversario, FrmRelAniversario);
  FrmRelAniversario.ShowModal;
Finally
  FrmRelAniversario.Free;
End;
end;

procedure TFrmPrincipal.DatadaltimaCompradoCliente1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmListCompraCli, FrmListCompraCli);
  FrmListCompraCli.ShowModal;
Finally
  FrmListCompraCli.Free;
End;    
end;

procedure TFrmPrincipal.InstruesparaBoletas1Click(Sender: TObject);
begin
Try
  Application.CreateForm(TFrmInst, FrmInst);
  FrmInst.ShowModal;
Finally
  FrmInst.Free;
End;     
end;

end.
