unit SaidaPedidos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls, Buttons;

type
  TFrmSaidaPedidos = class(TForm)
    TbClientes: TTable;
    TbProdutos: TTable;
    TbPedidos: TTable;
    TbItens: TTable;
    TbVendedor: TTable;
    TbFormaPag: TTable;
    TbClientesCodigo: TAutoIncField;
    TbClientesCodVendedor: TIntegerField;
    TbClientesNome: TStringField;
    TbClientesEndereco: TStringField;
    TbClientesBairro: TStringField;
    TbClientesCidade: TStringField;
    TbClientesUF: TStringField;
    TbClientesCEP: TStringField;
    TbClientesCGC: TStringField;
    TbClientesCPF: TStringField;
    TbClientesIE: TStringField;
    TbProdutosCodigo: TAutoIncField;
    TbProdutosDescricao: TStringField;
    TbProdutosModelo: TStringField;
    TbProdutosSaldo: TIntegerField;
    TbProdutosPrecoCusto: TCurrencyField;
    TbProdutosPrecoVenda: TCurrencyField;
    TbItensNroPed: TIntegerField;
    TbItensCodProduto: TIntegerField;
    TbItensQuantidade: TSmallintField;
    TbItensPreco: TCurrencyField;
    TbItensTroca: TSmallintField;
    TbItensAliq_ICMS: TCurrencyField;
    TbItensAliq_IPI: TCurrencyField;
    TbFormaPagCodigo: TAutoIncField;
    TbFormaPagDescricao: TStringField;
    TbFormaPagIntervaloDias: TSmallintField;
    TbFormaPagQtdParcelas: TSmallintField;
    TbFormaPagPrimVenc: TSmallintField;
    TbVendedorCodigo: TAutoIncField;
    TbVendedorVendedor: TStringField;
    TbVendedorEndereco: TStringField;
    TbVendedorBairro: TStringField;
    TbVendedorCidade: TStringField;
    TbVendedorUF: TStringField;
    TbVendedorCEP: TStringField;
    TbVendedorTelefone1: TStringField;
    TbVendedorTelefone2: TStringField;
    TbVendedorData: TDateField;
    TbVendedorCPF: TStringField;
    TbVendedorRG: TStringField;
    TbVendedorComisao: TSmallintField;
    TbPedidosNumero: TIntegerField;
    TbPedidosCodCliente: TIntegerField;
    TbPedidosCodVendedor: TIntegerField;
    TbPedidosCodFormaPag: TIntegerField;
    TbPedidosDataPed: TDateField;
    TbPedidosEntregue: TBooleanField;
    TbPedidosCliente: TStringField;
    TbPedidosVendedor: TStringField;
    TbPedidosFormaPag: TStringField;
    TbItensProduto: TStringField;
    DsItens: TDataSource;
    DsPedidos: TDataSource;
    DBGrid1: TDBGrid;
    TbItensTotal: TCurrencyField;
    DBGrid2: TDBGrid;
    DBNavigator1: TDBNavigator;
    Panel1: TPanel;
    Panel2: TPanel;
    QryTotal: TQuery;
    QryTotalTotal: TCurrencyField;
    TbPedidosCGC: TStringField;
    TbPedidosEndereco: TStringField;
    TbPedidosBairro: TStringField;
    TbPedidosCidade: TStringField;
    TbPedidosEstado: TStringField;
    TbPedidosCEP: TStringField;
    TbPedidosCPF: TStringField;
    TbPedidosIE: TStringField;
    BitBtn1: TBitBtn;
    TbPedidosObservacao: TMemoField;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TbItensCalcFields(DataSet: TDataSet);
    procedure TbPedidosAfterScroll(DataSet: TDataSet);
    Procedure Nota;
    procedure DBGrid2DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmSaidaPedidos: TFrmSaidaPedidos;

implementation

{$R *.DFM}

Procedure TFrmSaidaPedidos.Nota;
Var
  VarTotal:Real;
  I:Integer;
  Codigo,Produto,Qtd,Preco,Total,ICMS,IPI:String;
  Arq:TextFile;
  Numero,Vendedor,Data,FormaPag,
  Cliente,CGC,CPF,IE,
  Endereco,Bairro,Cidade,
  Estado,CEP,Obs:String;
Begin
Obs:=TbPedidosObservacao.Value;
Numero:=IntToStr(TbPedidosNumero.Value);
Data:=DateToStr(TbPedidosDataPed.Value);
FormaPag:=TbPedidosFormaPag.Value;
Cliente:=TbPedidosCliente.Value;
CGC:=TbPedidosCGC.Value;
CPF:=TbPedidosCPF.Value;
IE:=TbPedidosIE.Value;
Bairro:=TbPedidosBairro.Value;
Cidade:=TbPedidosCidade.Value;
Endereco:=TbPedidosEndereco.Value;
Estado:=TbPedidosEstado.Value;
Cep:=TbPedidosCEP.Value;
Vendedor:=TbPedidosVendedor.Value;
AssignFile(Arq,'C:\Windows\Desktop\Arq.txt');
ReWrite(Arq);
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Pedido                           APOLLO MASTER                                  ');
Writeln(Arq,'                         RUA PRIMEIRO DE MARO, 120/602                         ');
Writeln(Arq,'                    CENTRO-RIO DE JANEIRO-RJ-CEP: 20010-000                     ');
Writeln(Arq,'              TELEFONES: 253-5293 253-5416 233-5084 FAX: 233-6505               ');
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'');
Writeln(Arq,'Numero:   '+Numero+'       Vendedor: '+Vendedor);
Writeln(Arq,'Data:     '+Data+'                  Forma de Pagamento: '+FormaPag);
Writeln(Arq,'Cliente:  '+Cliente);
Writeln(Arq,'CGC:      '+CGC+'     CPF:  '+CPF+'   Insc. Estadual:  '+IE);
Writeln(Arq,'Endereo: '+Endereco);
Writeln(Arq,'Bairro:   '+Bairro+'     Cidade:  '+Cidade);
Writeln(Arq,'Estado:   '+Estado+'                     CEP:  '+CEP);
Writeln(Arq,'');
Writeln(Arq,'');
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Cdigo Produto                                  QTD    Preo     Total ICMS  IPI');
Writeln(Arq,'--------------------------------------------------------------------------------');
TbItens.First;
While not TbItens.Eof do
  Begin
    Codigo:=IntToStr(TbItensCodProduto.Value);
    Produto:=TbItensProduto.Value;
    Qtd:=IntToStr(TbItensQuantidade.Value);
    Preco:=FloatToStrF(TbItensPreco.Value,FFNumber,15,2);
    Total:=FloatToStrF(TbITensTotal.Value,FFNumber,15,2);
    ICMS:='0';
    IPI:='0';
    For I:=Length(Codigo) to 6 do
    Codigo:=Codigo+' ';
    For I:=Length(Produto) to 35 do
    Produto:=Produto+' ';
    For I:=Length(Qtd) to 7 do
    Qtd:=' '+Qtd;
    For I:=Length(Preco) to 8 do
    Preco:=' '+Preco;
    For I:=Length(Total) to 9 do
    Total:=' '+Total;
    Writeln(Arq,Codigo+Produto+QTD+Preco+Total+'    0    0');
    TbItens.Next;
  End;
For I:=TbItens.RecordCount to 20 do
begin
Writeln(Arq,'');
end;
Writeln(Arq,'--------------------------------------------------------------------------------');
VarTotal:=0;
TbItens.First;
While not TbItens.Eof do
  Begin
   VarTotal:=VarTotal+TbItensTotal.Value;
   TbItens.Next;
  End;

Writeln(Arq,'Valor ICMS: 0,00  Valor IPI: 0,00           Total do Pedido: '+FloatToStrF(VarTotal,FFNumber,15,2));
Writeln(Arq,'--------------------------------------------------------------------------------');
Writeln(Arq,'Observaes:');
if Length(Obs)<=80  then
  Begin
    For I:=1 to Length(Obs) do
      Begin
        Write(Arq,Obs[I]);
      end;
  End
Else if (Length(Obs)<=160) and (Length(Obs)>80) then
  Begin
    For I:=1 to 80 do
      Begin
        Write(Arq,Obs[I]);
      end;
    Writeln(Arq,'');
    For I:=81 to Length(Obs) do
      Begin
        Write(Arq,Obs[I]);
      end;
    Writeln(Arq,'');
  end;
Writeln(Arq,'--------------------------------------------------------------------------------');
CloseFile(arq);
end;

procedure TFrmSaidaPedidos.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  TbPedidos.Close;
  TbItens.Close;
  TbProdutos.Close;
  TbClientes.Close;
  TbVendedor.Close;
  TbFormaPag.Close;

end;

procedure TFrmSaidaPedidos.FormShow(Sender: TObject);
begin
  TbPedidos.Open;
  TbItens.Open;
  TbProdutos.Open;
  TbClientes.Open;
  TbVendedor.Open;
  TbFormaPag.Open;

end;

procedure TFrmSaidaPedidos.TbItensCalcFields(DataSet: TDataSet);
begin
TbITensTotal.Value:=TbITensQuantidade.Value*TbItensPreco.Value;
end;

procedure TFrmSaidaPedidos.TbPedidosAfterScroll(DataSet: TDataSet);
begin
With QryTotal do
  Begin
     close;
     ParamByName('VarNumero').AsInteger:=TbPedidosNumero.Value;
     Prepare;
     Open;
  End;
Panel2.Caption:='Valor Total do Pedido:'+FloatToStrF(QryTotalTotal.Value,FFCurrency,18,2);
end;

procedure TFrmSaidaPedidos.DBGrid2DblClick(Sender: TObject);
begin
TbPedidos.Edit;
TbPedidosEntregue.Value:=True;
TbPedidos.Post;
end;

end.
