unit Senha;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Buttons, ExtCtrls;

type
  TFrmSenha = class(TForm)
    TbSenha: TTable;
    TbSenhaUsuario: TStringField;
    TbSenhaSenha: TStringField;
    TbSenhaNivel: TSmallintField;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
   Per:Boolean;
  end;

var
  FrmSenha: TFrmSenha;

implementation

uses Global;

{$R *.DFM}

procedure TFrmSenha.FormShow(Sender: TObject);
begin
TbSenha.Open;
Per:=False;
Edit1.Clear;
Edit2.Clear;
Edit1.SetFocus;
end;

procedure TFrmSenha.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=Per;
If not Per Then
ShowMessage('Informe o Usurio e a Senha!');
end;

procedure TFrmSenha.BitBtn2Click(Sender: TObject);
begin
Per:=True;
GlbNivel:=0;
Close;
end;

procedure TFrmSenha.BitBtn1Click(Sender: TObject);
begin
if TbSenha.Locate('Usuario',Edit1.Text,[LoCaseInsensitive]) then
  begin
    if UpperCase(TbSenhaSenha.Value)=UpperCase(Edit2.Text) Then
      Begin
        Per:=True;
        GlbNivel:=TbSenhaNivel.Value;
        GlbUser:=TbSenhaUsuario.Value;
        Close;
      end
    Else
      Begin
         ShowMessage('Informe a Senha Corretamente!');
         Edit2.Clear;
         Edit2.SetFocus;
      End;
  end
Else
  Begin
    Edit1.Clear;
    Edit2.Clear;
    ShowMessage('Informe o Usurio e a Senha Corretamente!');
    Edit1.SetFocus;
  End;
end;

procedure TFrmSenha.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    Perform(WM_NEXTDLGCTL,0,0);
end;

procedure TFrmSenha.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if Key=#13 then
  Begin
    BitBtn1Click(sender);
  End;
end;

end.
