unit backup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables, Db, FileCtrl, ComCtrls, ExtCtrls, Buttons;

type
  TFrmBackup = class(TForm)
    FileListBox: TFileListBox;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Label1: TLabel;
    DriveComboBox2: TDriveComboBox;
    DirectoryListBox2: TDirectoryListBox;
    Label2: TLabel;
    TbOrigem: TTable;
    BatchMove: TBatchMove;
    TbDestino: TTable;
    Panel: TPanel;
    Animate1: TAnimate;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    PanelCopiando: TPanel;
    PanelDestino: TPanel;
    BtExecutar: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Image1: TImage;
    BtSair: TBitBtn;
    procedure itBtnExecutarClick(Sender: TObject);
    procedure BtExecutarClick(Sender: TObject);
    procedure btFecharClick(Sender: TObject);
    procedure BtSairClick(Sender: TObject);
    {procedure TestProgress(Count: SmallInt); nao funcionou }
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmBackup: TFrmBackup;

implementation

{$R *.DFM}




procedure TFrmBackup.itBtnExecutarClick(Sender: TObject);
var
 Indice: Integer;
 IndCampo: Integer;
 Campos: String;
begin
// Le todos os itens da Filelistbox para copiar
 // o databasename e constante
 if Directorylistbox1.Directory  = Directorylistbox2.Directory then // verifica se os diretorios sao diferentes
  begin
  showmessage('Diretorios de Destino e Origem devem ser diferentes !!');
  exit; // sai da procedure
  end;
 TbOrigem.DataBaseName:= Directorylistbox1.Directory ; // serao sempre constantes
 TbDestino.DataBaseName:= Directorylistbox2.Directory ;
 //ajusta o painel de copia animada
 panel.visible := true;
 Animate1.Active := true;
 for indice:= 0 to fileListBox.items.count - 1 do
  begin
   TbOrigem.tableName := filelistbox.items[indice];
   TbDestino.TableName:= filelistbox.items[indice];
   PanelCopiando.caption := label1.caption + '\' +
                            filelistbox.items[indice];
   PanelDestino.caption := label2.caption + '\' +
                            filelistbox.items[indice];

   { TestProgress(1000); // ativa progressbar nao funcionou}

   // essa linha forca o nome do arq. copiado a aparecer
   Application.ProcessMessages;
   // peca o help do tapplication e tscreen

   if  copy(filelistbox.items[indice],1,1) <> '_'then
       begin
          BatchMove.Execute; // executa copia

          //enchergar os indices para poder copia-los p/destino
          TbOrigem.open;
          Campos:='';
          for IndCampo:=0 to Tborigem.FieldCount - 1 do
             begin
               if TbOrigem.fields[indCampo].IsIndexField then
                 begin
                   if TbOrigem.Fields[indcampo].index = 0  then
                     Campos:=Campos + TbOrigem.Fields[indcampo].fieldname
                   else
                     Campos:=Campos + ';' + TbOrigem.fields[IndCampo].fieldname;
                 end; // begin
            end;
            TbOrigem.close;
            TbDestino.close;
            if campos <> '' then
              TbDestino.AddIndex('', Campos, [IxPrimary]);
            campos:='';
       end;

  end; // for
  panel.visible := false; // desliga a exibicao do painel animado de copia
  Animate1.Active := false;
  showmessage('Backup realizado !!!');
  frmbackup.Close;

end;

procedure TFrmBackup.BtExecutarClick(Sender: TObject);
var
 Indice: Integer;
 IndCampo: Integer;
 Campos: String;
begin
// Le todos os itens da Filelistbox para copiar
 // o databasename e constante
 if Directorylistbox1.Directory  = Directorylistbox2.Directory then // verifica se os diretorios sao diferentes
  begin
  showmessage('Diretorios de Destino e Origem devem ser diferentes !!');
  exit; // sai da procedure
  end;
 TbOrigem.DataBaseName:= Directorylistbox1.Directory ; // serao sempre constantes
 TbDestino.DataBaseName:= Directorylistbox2.Directory ;
 //ajusta o painel de copia animada
 panel.visible := true;
 Animate1.Active := true;
 for indice:= 0 to fileListBox.items.count - 1 do
  begin
   TbOrigem.tableName := filelistbox.items[indice];
   TbDestino.TableName:= filelistbox.items[indice];
   PanelCopiando.caption := label1.caption + '\' +
                            filelistbox.items[indice];
   PanelDestino.caption := label2.caption + '\' +
                            filelistbox.items[indice];

   { TestProgress(1000); // ativa progressbar nao funcionou}

   // essa linha forca o nome do arq. copiado a aparecer
   Application.ProcessMessages;
   // peca o help do tapplication e tscreen

   if  copy(filelistbox.items[indice],1,1) <> '_'then
       begin
          BatchMove.Execute; // executa copia

          //enchergar os indices para poder copia-los p/destino
          TbOrigem.open;
          Campos:='';
          for IndCampo:=0 to Tborigem.FieldCount - 1 do
             begin
               if TbOrigem.fields[indCampo].IsIndexField then
                 begin
                   if TbOrigem.Fields[indcampo].index = 0  then
                     Campos:=Campos + TbOrigem.Fields[indcampo].fieldname
                   else
                     Campos:=Campos + ';' + TbOrigem.fields[IndCampo].fieldname;
                 end; // begin
            end;
            TbOrigem.close;
            TbDestino.close;
            if campos <> '' then
              TbDestino.AddIndex('', Campos, [IxPrimary]);
            campos:='';
       end;

  end; // for
  panel.visible := false; // desliga a exibicao do painel animado de copia
  Animate1.Active := false;
  showmessage('Backup realizado com sucesso.');

end;

procedure TFrmBackup.btFecharClick(Sender: TObject);
begin
close;
end;


procedure TFrmBackup.BtSairClick(Sender: TObject);
begin
Close;
end;

end.
