unit Baixas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Db, Grids, DBGrids, DBTables,
  DBCtrls;

type
  TFrmBaixas = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    BtConsultar: TBitBtn;
    BtSair: TBitBtn;
    GroupBox2: TGroupBox;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    QryTitulos: TQuery;
    DBGrid1: TDBGrid;
    DsTitulos: TDataSource;
    QryTitulosVencimento: TDateField;
    QryTitulosCliente: TStringField;
    QryTitulosSaldo: TCurrencyField;
    QrySaldo: TQuery;
    QryTitulosNroTitulo: TIntegerField;
    QrySaldoTotal: TCurrencyField;
    QryTitulosValor: TCurrencyField;
    QryTitulosSituacao: TStringField;
    TbBaixas: TTable;
    TbBaixasNroTitulo: TIntegerField;
    TbBaixasNroBaixa: TAutoIncField;
    TbBaixasValor: TCurrencyField;
    TbBaixasDataPagamento: TDateField;
    DBGrid2: TDBGrid;
    Panel1: TPanel;
    DsBaixas: TDataSource;
    Panel2: TPanel;
    TbBaixasCodEspecie: TIntegerField;
    TbBaixasObservacao: TMemoField;
    TbEspecie: TTable;
    TbEspecieCodigo: TAutoIncField;
    TbEspecieEspecie: TStringField;
    TbBaixasEspecie: TStringField;
    DBMemo1: TDBMemo;
    Panel3: TPanel;
    procedure BtSairClick(Sender: TObject);
    procedure BtConsultarClick(Sender: TObject);
    procedure QryTitulosCalcFields(DataSet: TDataSet);
    procedure FormShow(Sender: TObject);
    procedure TbBaixasAfterPost(DataSet: TDataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmBaixas: TFrmBaixas;

implementation

{$R *.DFM}

procedure TFrmBaixas.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmBaixas.BtConsultarClick(Sender: TObject);
begin
Screen.Cursor:=crHourGlass;
TbBaixas.Close;
DsTitulos.DataSet:=nil;
With QryTitulos do
  Begin
   Close;
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   ParamByName('VarNome').AsString:=Edit1.Text+'%';
   Prepare;
   Open;
  End;
if RadioGroup1.ItemIndex = 1 then
  begin
    while not QryTitulos.EOF do
        if (QryTitulosSituacao.Value = 'No') or
           (QryTitulosSituacao.Value = 'Parcial') then
               QryTitulos.Delete
         else
           QryTitulos.Next;
   end;
if RadioGroup1.ItemIndex = 2 then
   begin
     while not QryTitulos.EOF do
         if (QryTitulosSituacao.Value = 'Sim') then
            QryTitulos.Delete
          else
            QryTitulos.Next;
    end;
QryTitulos.Refresh;
DsTitulos.DataSet:=QryTitulos;
TbBaixas.Open;
Screen.Cursor:=crDefault;
end;

procedure TFrmBaixas.QryTitulosCalcFields(DataSet: TDataSet);
begin
with QrySaldo do
  Begin
   Close;
   ParamByName('VarNumero').AsInteger:=QryTitulosNroTitulo.Value;
   Prepare;
   Open;
  end;
    QryTitulosSaldo.Value:=StrToFloat(FloatToStrF((QryTitulosValor.Value -
                                      QrySaldoTotal.Value), ffnumber, 15, 2));
   if FloatToStrF(QryTitulosSaldo.Value,ffnumber, 15, 2) =
      FloatToStrF(QryTitulosValor.Value,ffnumber, 15, 2) then
      QryTitulosSituacao.Value:='No'
   else if QryTitulosSaldo.Value = 0 then
           QryTitulosSituacao.Value:='Sim'
   else if (QryTitulosSaldo.Value < QryTitulosValor.Value) and
           (QryTitulosSaldo.Value <> 0)  then
           QryTitulosSituacao.Value:='Parcial';
end;

procedure TFrmBaixas.FormShow(Sender: TObject);
begin
Data1.Date:=Date-15;
Data2.Date:=Date+15;
TbEspecie.Open;
end;

procedure TFrmBaixas.TbBaixasAfterPost(DataSet: TDataSet);
begin
BtConsultarClick(DataSet);
end;

procedure TFrmBaixas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbEspecie.Close;
end;

end.
