unit Comissao;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Db, DBCtrls, DBTables, Buttons;

type
  TFrmComissao = class(TForm)
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    QryVendedor: TQuery;
    QryVendedorCodigo: TIntegerField;
    QryVendedorVendedor: TStringField;
    DBLookupComboBox1: TDBLookupComboBox;
    DsVendedor: TDataSource;
    Label3: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmComissao: TFrmComissao;

implementation

uses RelComisao;

{$R *.DFM}

procedure TFrmComissao.FormShow(Sender: TObject);
begin
Screen.Cursor:=CrHourGlass;
QryVendedor.Open;
Data1.Date:=Date-30;
Data2.Date:=Date;
Screen.Cursor:=CrDefault;
end;

procedure TFrmComissao.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
QryVendedor.Close;
end;

procedure TFrmComissao.BitBtn3Click(Sender: TObject);
begin
Close;
end;

procedure TFrmComissao.BitBtn2Click(Sender: TObject);
begin
   Try
      Application.CreateForm(TFrmRelComisao, FrmRelComisao);
     With  FrmRelComisao do
       Begin
         QryComisao.ParamByName('VarDataI').AsDate:=Data1.Date;
         QryComisao.ParamByName('VarDataF').AsDate:=Data2.Date;
         QryComisao.ParamByName('VarVendedor').AsString:=DbLookUpComboBox1.Text+'%';   
         QryComisao.Prepare;
         QryComisao.Open;
         QuickRep1.Preview;
         QryComisao.Close;
       end;
      Finally
    FrmRelComisao.Free;
 End;
end;

end.
