unit ConsEntradas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Consulta, StdCtrls, Buttons, ComCtrls, Grids, DBGrids, Db, DBTables;

type
  TFrmConsEntradas = class(TFrmConsulta)
    Edit1: TEdit;
    Label1: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    QryEntradas: TQuery;
    DsEntradas: TDataSource;
    DBGrid1: TDBGrid;
    QryEntradasNumero: TStringField;
    QryEntradasDataEmissao: TDateField;
    QryEntradasFornecedor: TStringField;
    procedure BtSairClick(Sender: TObject);
    procedure BtConsultarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure Data1CloseUp(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmConsEntradas: TFrmConsEntradas;

implementation

uses Global;

{$R *.DFM}

procedure TFrmConsEntradas.BtSairClick(Sender: TObject);
begin
  inherited;
Close;
end;

procedure TFrmConsEntradas.BtConsultarClick(Sender: TObject);
begin
  inherited;
With QryEntradas Do
  Begin
   Close;
   ParamByName('VarFornecedor').AsString:=Edit1.Text+'%';
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   Prepare;
   Open;
  End;
if QryEntradas.RecordCount=0 then
  Begin
   ShowMessage('Nenhuma Entrada foi Encontrada com esses Dados Fornecidos!');
  End;
end;

procedure TFrmConsEntradas.FormShow(Sender: TObject);
begin
  inherited;
Edit1.SetFocus;
Data2.Date:=Date;
Data1.Date:=Date-10;
end;

procedure TFrmConsEntradas.DBGrid1DblClick(Sender: TObject);
begin
  inherited;
GlbNumero:=QryEntradasNumero.Value;
Close;
end;

procedure TFrmConsEntradas.Data1CloseUp(Sender: TObject);
begin
  inherited;
 if Data1.Date>Data2.Date Then
 Begin
   ShowMessage('A Data Inicial no pode ser Maior que a Data Final!');
   Data1.date:=Data2.date;
 end;
end;

end.
