unit ConsPedidos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Consulta, StdCtrls, Buttons, Db, DBTables, Grids, DBGrids, ComCtrls;

type
  TFrmConsPedidos = class(TFrmConsulta)
    QryPedidos: TQuery;
    DBGrid1: TDBGrid;
    DsPedidos: TDataSource;
    Edit1: TEdit;
    Label1: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    QryPedidosNumero: TIntegerField;
    QryPedidosDataPed: TDateField;
    QryPedidosNome: TStringField;
    procedure BtSairClick(Sender: TObject);
    procedure BtConsultarClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Data1CloseUp(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmConsPedidos: TFrmConsPedidos;

implementation

uses Global;

{$R *.DFM}

procedure TFrmConsPedidos.BtSairClick(Sender: TObject);
begin
Close;

end;

procedure TFrmConsPedidos.BtConsultarClick(Sender: TObject);
begin
With QryPedidos Do
  Begin
   Close;
   ParamByName('VarCliente').AsString:=Edit1.Text+'%';
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   Prepare;
   Open;
  End;
if QryPedidos.RecordCount=0 then
  Begin
   ShowMessage('Nenhum Pedido foi Encontrado com esses Dados!');
  End;
end;

procedure TFrmConsPedidos.DBGrid1DblClick(Sender: TObject);
begin
  GlbCodigo:=QryPedidosNumero.Value;
  Close;
end;

procedure TFrmConsPedidos.FormShow(Sender: TObject);
begin
  inherited;
data2.Date:=Date;
Data1.Date:=Date-10;
end;

procedure TFrmConsPedidos.Data1CloseUp(Sender: TObject);
begin
  inherited;
 if Data1.Date>Data2.Date Then
 Begin
   ShowMessage('A Data Inicial no pode ser Maior que a Data Final!');
   Data1.date:=Data2.date;
 end;

end;

end.
