unit GrfProdutosVendidos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Db, DBTables, Buttons, TeEngine, Series,
  TeeProcs, Chart, DBChart, QrTee, QuickRpt;

type
  TFrmGrfProdutosVendidos = class(TForm)
    Panel1: TPanel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BtSair: TBitBtn;
    QryGrafico: TQuery;
    QryGraficoTotal: TCurrencyField;
    QryGraficoDescricao: TStringField;
    DBChart1: TDBChart;
    Series1: TPieSeries;
    BitBtn2: TBitBtn;
    Panel2: TPanel;
    QuickRep1: TQuickRep;
    TitleBand1: TQRBand;
    QRDBChart1: TQRDBChart;
    QRChart1: TQRChart;
    Series2: TPieSeries;
    procedure BitBtn1Click(Sender: TObject);
    procedure BtSairClick(Sender: TObject);
    procedure Data1CloseUp(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmGrfProdutosVendidos: TFrmGrfProdutosVendidos;

implementation

uses RelGrfProdutosVendidos;

{$R *.DFM}

procedure TFrmGrfProdutosVendidos.BitBtn1Click(Sender: TObject);
begin
With QryGrafico do
  Begin
   Close;
   ParamByName('VarDataI').AsDate:=Data1.Date;
   ParamByName('VarDataF').AsDate:=Data2.Date;
   Prepare;
   Open;
  End;
If (QryGrafico.RecordCount=1) and (QryGraficoTotal.Value=0) then
  ShowMessage('No Existe Vendas Neste Perodo Informado!');
end;

procedure TFrmGrfProdutosVendidos.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmGrfProdutosVendidos.Data1CloseUp(Sender: TObject);
begin
if data1.date>data2.date then
  Begin
    ShowMessage('A Data Inicial no Pode ser menor que a Data Final!');
    data1.date:=data2.date;
  end;

end;

procedure TFrmGrfProdutosVendidos.FormShow(Sender: TObject);
begin
data2.date:=date;
data1.date:=date-30;
end;

procedure TFrmGrfProdutosVendidos.BitBtn2Click(Sender: TObject);
begin
QuickRep1.Preview;
end;

end.
