unit RelPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TFrmRelPrincipal = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Data1: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    Data2: TDateTimePicker;
    Bevel1: TBevel;
    PrintSetup: TPrinterSetupDialog;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmRelPrincipal: TFrmRelPrincipal;

implementation

uses RelPedidos, RelComisao, Global, RelTrocas;

{$R *.DFM}

procedure TFrmRelPrincipal.BitBtn2Click(Sender: TObject);
begin
if GlbEscolha='P' Then
Begin
Try
  Application.CreateForm(TFrmRelPedidos, FrmRelPedidos);
  With FrmRelPedidos do
   Begin
    TbItens.Open;
    TbFormaPag.Open;
    TbPedidos.ParamByName('VarDataI').AsDate:=Data1.Date;
    TbPedidos.ParamByName('VarDataF').AsDate:=Data2.Date;
    TbPedidos.Prepare;
    TbPedidos.Open;
    TbProdutos.Open;
    TbVendedor.Open;
    TbClientes.Open;
    TbTitulos.Open;
    QuickRep1.Preview;
    TbTitulos.Close;
    TbItens.Close;
    TbFormaPag.Close;
    TbPedidos.Close;
    TbProdutos.Close;
    TbVendedor.Close;
    TbClientes.Close;
   End;
Finally
  FrmRelPedidos.Free;
End;
End;

Try
  Application.CreateForm(TFrmRelTrocas, FrmRelTrocas);
  With FrmRelTrocas do
    begin
      QryTrocas.ParamByName('VarDataI').AsDate:=Data1.Date;
      QryTrocas.ParamByName('VarDataF').AsDate:=Data2.Date;
      QryTrocas.Prepare;
      QryTrocas.Open;
      QuickRep1.Preview;
      QryTrocas.Close;
    End;
Finally
  FrmRelTrocas.Free;
End;
end;

procedure TFrmRelPrincipal.FormShow(Sender: TObject);
begin
Data2.Date:=date;
Data1.Date:=date-30;
end;

procedure TFrmRelPrincipal.BitBtn1Click(Sender: TObject);
begin
if GlbEscolha='P' Then
Begin
Try
  Application.CreateForm(TFrmRelPedidos, FrmRelPedidos);
  With FrmRelPedidos do
   Begin
    TbTitulos.Open;
    TbItens.Open;
    TbFormaPag.Open;
    TbPedidos.ParamByName('VarDataI').AsDate:=Data1.Date;
    TbPedidos.ParamByName('VarDataF').AsDate:=Data2.Date;
    TbPedidos.Prepare;
    TbPedidos.Open;
    TbProdutos.Open;
    TbVendedor.Open;
    TbClientes.Open;
    QuickRep1.Print;
    TbTitulos.Close;
    TbItens.Close;
    TbFormaPag.Close;
    TbPedidos.Close;
    TbProdutos.Close;
    TbVendedor.Close;
    TbClientes.Close;
   End;
Finally
  FrmRelPedidos.Free;
End;
End;
if GlbEscolha='C' Then
 Begin
   Try
      Application.CreateForm(TFrmRelComisao, FrmRelComisao);
     With  FrmRelComisao do
       Begin
         QryComisao.ParamByName('VarDataI').AsDate:=Data1.Date;
         QryComisao.ParamByName('VarDataF').AsDate:=Data2.Date;
         QryComisao.Prepare;
         QryComisao.Open;
         QuickRep1.Print;
         QryComisao.Close;
       end;
      Finally
    FrmRelComisao.Free;
 End;
 end;
end;

procedure TFrmRelPrincipal.BitBtn3Click(Sender: TObject);
begin
PrintSetup.Execute;
end;

end.
